//Import needed stuff
import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;

//Testing class
public class Testing
{	
	//Constructor
	public Testing()
	{
		System.out.println("In constructor");
	}
	
	//This method is invoked before 
	//JUnite test case executes
	@ Before
	public void setUp()
	{
		System.out.println("In setUp");
	}

	//This method is invoked after 
	//JUnit test case is executed
	@ After
	public void tearDown() 
	{
		System.out.println("In tearDown");
	}

	//Test 1
	@Test
	public void testValueEquality() 
	{
		//Value checking
		assertTrue(new String("Cisco").equals("Cisco"));
		//Value checking different syntax
		assertTrue(Objects.equals(new String("Cisco"), "Cisco"));
		//Value checking against a null
		assertFalse(Objects.equals(null, "Cisco"));
	}

	//Test 2
	@Test
	public void testObjectEquality() 
	{
		//Same value but not same objects
		assertFalse(new String("Cisco") == "Cisco");
		//Same value but not same objects
		assertFalse(new String("Cisco") == new String("Cisco"));
		//In this case they are internally the same object
		assertTrue("Cisco" == "Cisco");
	}

	//Test 3
	@Test
	public void testAlphabeticalOrder() 
	{
		//Lexographic comparison
		assertTrue(new String("Cisco").compareTo("Apple") > 0);
		assertTrue(new String("Apple").compareTo("Cisco") < 0);
		assertTrue(new String("Cisco").compareTo("Cisco") == 0);
	}
}
